# This definitely needs cleaning
using OrdinaryDiffEqPDIRK, ODEProblemLibrary, DiffEqDevTools
using Test, Random
Random.seed!(100)

## Convergence Testing
testTol = 0.2

@testset "Implicit Solver Convergence Tests ($(["out-of-place", "in-place"][i]))" for i in 1:2
    dts = 1 .// 2 .^ (9:-1:5)
    prob = (
        ODEProblemLibrary.prob_ode_linear,
        ODEProblemLibrary.prob_ode_2Dlinear,
    )[i]
    sim18 = test_convergence(dts, prob, PDIRK44())
    @test sim18.𝒪est[:final] ≈ 4 atol = testTol

    sim182 = test_convergence(dts, prob, PDIRK44(; threading = false))
    @test sim182.𝒪est[:final] ≈ 4 atol = testTol
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

# Run QA tests (JET, Aqua)
if TEST_GROUP != "Core" && isempty(VERSION.prerelease)
    @time @safetestset "JET Tests" include("jet.jl")
end

@time @safetestset "Convergence Tests" include("pdirk_convergence_tests.jl")

@doc differentiation_rk_docstring(
    "A 2 processor 4th order diagonally non-adaptive implicit method.",
    "PDIRK44",
    "Parallel Diagonally Implicit Runge-Kutta Method.";
    references = """"@article{iserles1990theory,
    title={On the theory of parallel Runge—Kutta methods},
    author={Iserles, Arieh and Norrsett, SP},
    journal={IMA Journal of numerical Analysis},
    volume={10},
    number={4},
    pages={463--488},
    year={1990},
    publisher={Oxford University Press}}""",
    extra_keyword_description = """
    - `nlsolve`: TBD,
    - `extrapolant`: TBD,
    - `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
    """,
    extra_keyword_default = """
    nlsolve = NLNewton(),
    extrapolant = :constant,
    thread = OrdinaryDiffEq.True(),
    """
)
struct PDIRK44{CS, AD, F, F2, P, FDT, ST, CJ, TO} <:
    OrdinaryDiffEqNewtonAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    nlsolve::F2
    precs::P
    extrapolant::Symbol
    threading::TO
    autodiff::AD
end
function PDIRK44(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(), standardtag = Val{true}(),
        concrete_jac = nothing, diff_type = Val{:forward}(),
        linsolve = nothing, precs = DEFAULT_PRECS, nlsolve = NLNewton(),
        extrapolant = :constant, threading = true
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    return PDIRK44{
        _unwrap_val(chunk_size), typeof(AD_choice), typeof(linsolve),
        typeof(nlsolve), typeof(precs), diff_type, _unwrap_val(standardtag),
        _unwrap_val(concrete_jac), typeof(threading),
    }(
        linsolve, nlsolve, precs,
        extrapolant, threading, AD_choice
    )
end

function initialize!(integrator, cache::PDIRK44ConstantCache) end

@muladd function perform_step!(integrator, cache::PDIRK44ConstantCache, repeat_step = false)
    (; dt, uprev, u) = integrator
    alg = unwrap_alg(integrator, true)
    (; nlsolver, tab) = cache
    (; γs, cs, α1, α2, b1, b2, b3, b4) = tab

    if isthreaded(alg.threading)
        k2 = Array{typeof(u)}(undef, 2)
        k1 = Array{typeof(u)}(undef, 2)
        let nlsolver = nlsolver, u = u, uprev = uprev, integrator = integrator,
                cache = cache, dt = dt, repeat_step = repeat_step,
                k1 = k1

            @threaded alg.threading for i in 1:2
                nlsolver[i].z = zero(u)
                nlsolver[i].tmp = uprev
                nlsolver[i].γ = γs[i]
                nlsolver[i].c = cs[i]
                markfirststage!(nlsolver[i])
                k1[i] = nlsolve!(nlsolver[i], integrator, cache, repeat_step)
            end
        end
        nlsolvefail(nlsolver[1]) && return
        nlsolvefail(nlsolver[2]) && return
        let nlsolver = nlsolver, u = u, uprev = uprev, integrator = integrator,
                cache = cache, dt = dt, repeat_step = repeat_step,
                k1 = k1, k2 = k2

            @threaded alg.threading for i in 1:2
                nlsolver[i].c = cs[2 + i]
                nlsolver[i].z = zero(u)
                nlsolver[i].tmp = uprev + α1[i] * k1[1] + α2[i] * k1[2]
                k2[i] = nlsolve!(nlsolver[i], integrator, cache, repeat_step)
            end
        end
        nlsolvefail(nlsolver[1]) && return
        nlsolvefail(nlsolver[2]) && return
        integrator.u = uprev + b1 * k1[1] + b2 * k2[1] + b3 * k1[2] + b4 * k2[2]
    else
        _nlsolver = nlsolver[1]
        _nlsolver.z = zero(u)
        _nlsolver.tmp = uprev
        _nlsolver.γ = γs[1]
        _nlsolver.c = cs[1]
        markfirststage!(_nlsolver)
        k11 = nlsolve!(_nlsolver, integrator, γs[1] * dt, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z = zero(u)
        _nlsolver.tmp = uprev
        _nlsolver.γ = γs[2]
        _nlsolver.c = cs[2]
        markfirststage!(_nlsolver)
        k12 = nlsolve!(_nlsolver, integrator, γs[2] * dt, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z = zero(u)
        _nlsolver.tmp = uprev + α1[1] * k11 + α2[1] * k12
        _nlsolver.γ = γs[1]
        _nlsolver.c = cs[3]
        markfirststage!(_nlsolver)
        k21 = nlsolve!(_nlsolver, integrator, γs[1] * dt, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z = zero(u)
        _nlsolver.tmp = uprev + α1[2] * k11 + α2[2] * k12
        _nlsolver.γ = γs[2]
        _nlsolver.c = cs[4]
        markfirststage!(_nlsolver)
        k22 = nlsolve!(_nlsolver, integrator, γs[2] * dt, repeat_step)
        nlsolvefail(_nlsolver) && return
        integrator.u = uprev + b1 * k11 + b2 * k21 + b3 * k12 + b4 * k22
    end
end

function initialize!(integrator, cache::PDIRK44Cache) end

@muladd function perform_step!(integrator, cache::PDIRK44Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, true)
    (; nlsolver, k1, k2, tab) = cache
    (; γs, cs, α1, α2, b1, b2, b3, b4) = tab
    if isthreaded(alg.threading)
        let nlsolver = nlsolver, u = u, uprev = uprev, integrator = integrator,
                cache = cache, dt = dt, repeat_step = repeat_step,
                k1 = k1

            @threaded alg.threading for i in 1:2
                nlsolver[i].z .= zero(eltype(u))
                nlsolver[i].tmp .= uprev
                nlsolver[i].γ = γs[i]
                nlsolver[i].c = cs[i]
                markfirststage!(nlsolver[i])
                k1[i] .= nlsolve!(nlsolver[i], integrator, cache, repeat_step)
            end
        end
        nlsolvefail(nlsolver[1]) && return
        nlsolvefail(nlsolver[2]) && return
        let nlsolver = nlsolver, u = u, uprev = uprev, integrator = integrator,
                cache = cache, dt = dt, repeat_step = repeat_step,
                k1 = k1, k2 = k2

            @threaded alg.threading for i in 1:2
                nlsolver[i].c = cs[2 + i]
                nlsolver[i].z .= zero(eltype(u))
                @.. broadcast = false nlsolver[i].tmp = uprev + α1[i] * k1[1] + α2[i] * k1[2]
                k2[i] .= nlsolve!(nlsolver[i], integrator, cache, repeat_step)
            end
        end
        nlsolvefail(nlsolver[1]) && return
        nlsolvefail(nlsolver[2]) && return
    else
        _nlsolver = nlsolver[1]
        _nlsolver.z .= zero(eltype(u))
        _nlsolver.tmp .= uprev
        _nlsolver.γ = γs[1]
        _nlsolver.c = cs[1]
        markfirststage!(_nlsolver)
        k1[1] .= nlsolve!(_nlsolver, integrator, cache, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z .= zero(eltype(u))
        _nlsolver.tmp .= uprev
        _nlsolver.γ = γs[2]
        _nlsolver.c = cs[2]
        markfirststage!(_nlsolver)
        k1[2] .= nlsolve!(_nlsolver, integrator, cache, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z .= zero(eltype(u))
        @.. broadcast = false _nlsolver.tmp = uprev + α1[1] * k1[1] + α2[1] * k1[2]
        _nlsolver.γ = γs[1]
        _nlsolver.c = cs[3]
        markfirststage!(_nlsolver)
        k2[1] .= nlsolve!(_nlsolver, integrator, cache, repeat_step)
        nlsolvefail(_nlsolver) && return
        _nlsolver.z .= zero(eltype(u))
        @.. broadcast = false _nlsolver.tmp = uprev + α1[2] * k1[1] + α2[2] * k1[2]
        _nlsolver.γ = γs[2]
        _nlsolver.c = cs[4]
        markfirststage!(_nlsolver)
        k2[2] .= nlsolve!(_nlsolver, integrator, cache, repeat_step)
        nlsolvefail(_nlsolver) && return
    end
    @.. broadcast = false u = uprev + b1 * k1[1] + b2 * k2[1] + b3 * k1[2] + b4 * k2[2]
end

module OrdinaryDiffEqPDIRK

import OrdinaryDiffEqCore: isfsal, alg_order, _unwrap_val,
    OrdinaryDiffEqNewtonAlgorithm, OrdinaryDiffEqConstantCache,
    OrdinaryDiffEqMutableCache, constvalue, alg_cache,
    uses_uprev, unwrap_alg, @cache, DEFAULT_PRECS,
    @threaded, initialize!, perform_step!, isthreaded,
    full_cache, get_fsalfirstlast, differentiation_rk_docstring,
    _bool_to_ADType, _process_AD_choice
import MuladdMacro: @muladd
import FastBroadcast: @..
using Polyester

using Reexport
@reexport using SciMLBase

using OrdinaryDiffEqDifferentiation: dolinsolve
using OrdinaryDiffEqNonlinearSolve: NLNewton, build_nlsolver, nlsolve!, nlsolvefail,
    markfirststage!

import ADTypes: AutoForwardDiff, AbstractADType

include("algorithms.jl")
include("alg_utils.jl")
include("pdirk_caches.jl")
include("pdirk_perform_step.jl")

export PDIRK44

end

@cache struct PDIRK44Cache{uType, rateType, N, TabType} <: OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k1::Array{rateType}
    k2::Array{rateType}
    nlsolver::N
    tab::TabType
end

# Non-FSAL
get_fsalfirstlast(cache::PDIRK44Cache, u) = (nothing, nothing)

struct PDIRK44ConstantCache{N, TabType} <: OrdinaryDiffEqConstantCache
    nlsolver::N
    tab::TabType
end

struct PDIRK44Tableau{T, T2}
    γs::NTuple{2, T2}
    cs::NTuple{4, T2}
    α1::NTuple{2, T}
    α2::NTuple{2, T}
    b1::T
    b2::T
    b3::T
    b4::T
end

function PDIRK44Tableau(T, T2)
    γ1 = convert(T2, 1 // 2)
    γ2 = convert(T2, 2 // 3)
    γs = (γ1, γ2)
    c1 = convert(T2, 1 // 2)
    c2 = convert(T2, 2 // 3)
    c3 = convert(T2, 1 // 2)
    c4 = convert(T2, 1 // 3)
    cs = (c1, c2, c3, c4)
    α11 = convert(T, -5 // 2)
    α12 = convert(T, -5 // 3)
    α1 = (α11, α12)
    α21 = convert(T, 5 // 2)
    α22 = convert(T, 4 // 3)
    α2 = (α21, α22)
    b1 = convert(T, -1 // 1)
    b2 = convert(T, -1 // 1)
    b3 = convert(T, 3 // 2)
    b4 = convert(T, 3 // 2)
    return PDIRK44Tableau{T, T2}(γs, cs, α1, α2, b1, b2, b3, b4)
end

function alg_cache(
        alg::PDIRK44, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    γ, c = 1.0, 1.0
    if alg.threading
        nlsolver1 = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(true), verbose
        )
        nlsolver2 = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(true), verbose
        )
        nlsolver = [nlsolver1, nlsolver2]
    else
        _nlsolver = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(true), verbose
        )
        nlsolver = [_nlsolver]
    end
    tab = PDIRK44Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    k1 = [zero(rate_prototype) for i in 1:2]
    k2 = [zero(rate_prototype) for i in 1:2]
    return PDIRK44Cache(u, uprev, k1, k2, nlsolver, tab)
end

function alg_cache(
        alg::PDIRK44, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    γ, c = 1.0, 1.0
    if alg.threading
        nlsolver1 = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(false), verbose
        )
        nlsolver2 = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(false), verbose
        )
        nlsolver = [nlsolver1, nlsolver2]
    else
        _nlsolver = build_nlsolver(
            alg, u, uprev, p, t, dt, f, rate_prototype,
            uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits, γ, c,
            Val(false), verbose
        )
        nlsolver = [_nlsolver]
    end
    tab = PDIRK44Tableau(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return PDIRK44ConstantCache(nlsolver, tab)
end
